/**
 * <copyright>
 * </copyright>
 *
 * $Id: ConstraintImpl.java,v 1.4 2004/11/03 15:19:10 frank Exp $
 */
package VOCLModel.impl;

import VOCLModel.Constraint;
import VOCLModel.Context;
import VOCLModel.ExpressionType;
import VOCLModel.Kind;
import VOCLModel.VOCLDiagramm;
import VOCLModel.VOCLExpression;
import VOCLModel.VOCLModel4Package;
import VOCLModel.VariableDeclaration;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Constraint</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link VOCLModel.impl.ConstraintImpl#getExptype <em>Exptype</em>}</li>
 *   <li>{@link VOCLModel.impl.ConstraintImpl#isIsNegated <em>Is Negated</em>}</li>
 *   <li>{@link VOCLModel.impl.ConstraintImpl#getConstraint <em>Constraint</em>}</li>
 *   <li>{@link VOCLModel.impl.ConstraintImpl#getX <em>X</em>}</li>
 *   <li>{@link VOCLModel.impl.ConstraintImpl#getY <em>Y</em>}</li>
 *   <li>{@link VOCLModel.impl.ConstraintImpl#getWidth <em>Width</em>}</li>
 *   <li>{@link VOCLModel.impl.ConstraintImpl#getHeight <em>Height</em>}</li>
 *   <li>{@link VOCLModel.impl.ConstraintImpl#getKind <em>Kind</em>}</li>
 *   <li>{@link VOCLModel.impl.ConstraintImpl#getContext <em>Context</em>}</li>
 *   <li>{@link VOCLModel.impl.ConstraintImpl#getVOCLDiagramm <em>VOCL Diagramm</em>}</li>
 *   <li>{@link VOCLModel.impl.ConstraintImpl#getVOCLExpression <em>VOCL Expression</em>}</li>
 *   <li>{@link VOCLModel.impl.ConstraintImpl#getVariableDeclaration <em>Variable Declaration</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ConstraintImpl extends ModelElementImpl implements Constraint
{
  /**
   * The default value of the '{@link #getExptype() <em>Exptype</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExptype()
   * @generated
   * @ordered
   */
  protected static final ExpressionType EXPTYPE_EDEFAULT = ExpressionType.EXP_LITERAL;

  /**
   * The cached value of the '{@link #getExptype() <em>Exptype</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExptype()
   * @generated
   * @ordered
   */
  protected ExpressionType exptype = EXPTYPE_EDEFAULT;

  /**
   * The default value of the '{@link #isIsNegated() <em>Is Negated</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isIsNegated()
   * @generated
   * @ordered
   */
  protected static final boolean IS_NEGATED_EDEFAULT = false;

  /**
   * The cached value of the '{@link #isIsNegated() <em>Is Negated</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isIsNegated()
   * @generated
   * @ordered
   */
  protected boolean isNegated = IS_NEGATED_EDEFAULT;

  /**
   * The default value of the '{@link #getX() <em>X</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getX()
   * @generated
   * @ordered
   */
  protected static final int X_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getX() <em>X</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getX()
   * @generated
   * @ordered
   */
  protected int x = X_EDEFAULT;

  /**
   * The default value of the '{@link #getY() <em>Y</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getY()
   * @generated
   * @ordered
   */
  protected static final int Y_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getY() <em>Y</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getY()
   * @generated
   * @ordered
   */
  protected int y = Y_EDEFAULT;

  /**
   * The default value of the '{@link #getWidth() <em>Width</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWidth()
   * @generated
   * @ordered
   */
  protected static final int WIDTH_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getWidth() <em>Width</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWidth()
   * @generated
   * @ordered
   */
  protected int width = WIDTH_EDEFAULT;

  /**
   * The default value of the '{@link #getHeight() <em>Height</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHeight()
   * @generated
   * @ordered
   */
  protected static final int HEIGHT_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getHeight() <em>Height</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHeight()
   * @generated
   * @ordered
   */
  protected int height = HEIGHT_EDEFAULT;

  /**
   * The default value of the '{@link #getKind() <em>Kind</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getKind()
   * @generated
   * @ordered
   */
  protected static final Kind KIND_EDEFAULT = Kind.INV_LITERAL;

  /**
   * The cached value of the '{@link #getKind() <em>Kind</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getKind()
   * @generated
   * @ordered
   */
  protected Kind kind = KIND_EDEFAULT;

  /**
   * The cached value of the '{@link #getContext() <em>Context</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getContext()
   * @generated
   * @ordered
   */
  protected Context context = null;

  /**
   * The cached value of the '{@link #getVOCLExpression() <em>VOCL Expression</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVOCLExpression()
   * @generated
   * @ordered
   */
  protected VOCLExpression vOCLExpression = null;

  /**
   * The cached value of the '{@link #getVariableDeclaration() <em>Variable Declaration</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVariableDeclaration()
   * @generated
   * @ordered
   */
  protected EList variableDeclaration = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ConstraintImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected EClass eStaticClass()
  {
    return VOCLModel4Package.eINSTANCE.getConstraint();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ExpressionType getExptype()
  {
    return exptype;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setExptype(ExpressionType newExptype)
  {
    ExpressionType oldExptype = exptype;
    exptype = newExptype == null ? EXPTYPE_EDEFAULT : newExptype;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModel4Package.CONSTRAINT__EXPTYPE, oldExptype, exptype));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isIsNegated()
  {
    return isNegated;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setIsNegated(boolean newIsNegated)
  {
    boolean oldIsNegated = isNegated;
    isNegated = newIsNegated;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModel4Package.CONSTRAINT__IS_NEGATED, oldIsNegated, isNegated));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Constraint getConstraint()
  {
    if (eContainerFeatureID != VOCLModel4Package.CONSTRAINT__CONSTRAINT) return null;
    return (Constraint)eContainer;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setConstraint(Constraint newConstraint)
  {
    if (newConstraint != eContainer || (eContainerFeatureID != VOCLModel4Package.CONSTRAINT__CONSTRAINT && newConstraint != null))
    {
      if (EcoreUtil.isAncestor(this, newConstraint))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eContainer != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newConstraint != null)
        msgs = ((InternalEObject)newConstraint).eInverseAdd(this, VOCLModel4Package.CONSTRAINT__VOCL_EXPRESSION, Constraint.class, msgs);
      msgs = eBasicSetContainer((InternalEObject)newConstraint, VOCLModel4Package.CONSTRAINT__CONSTRAINT, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModel4Package.CONSTRAINT__CONSTRAINT, newConstraint, newConstraint));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getX()
  {
    return x;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setX(int newX)
  {
    int oldX = x;
    x = newX;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModel4Package.CONSTRAINT__X, oldX, x));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getY()
  {
    return y;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setY(int newY)
  {
    int oldY = y;
    y = newY;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModel4Package.CONSTRAINT__Y, oldY, y));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getWidth()
  {
    return width;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setWidth(int newWidth)
  {
    int oldWidth = width;
    width = newWidth;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModel4Package.CONSTRAINT__WIDTH, oldWidth, width));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getHeight()
  {
    return height;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHeight(int newHeight)
  {
    int oldHeight = height;
    height = newHeight;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModel4Package.CONSTRAINT__HEIGHT, oldHeight, height));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Kind getKind()
  {
    return kind;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setKind(Kind newKind)
  {
    Kind oldKind = kind;
    kind = newKind == null ? KIND_EDEFAULT : newKind;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModel4Package.CONSTRAINT__KIND, oldKind, kind));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Context getContext()
  {
    return context;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetContext(Context newContext, NotificationChain msgs)
  {
    Context oldContext = context;
    context = newContext;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, VOCLModel4Package.CONSTRAINT__CONTEXT, oldContext, newContext);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setContext(Context newContext)
  {
    if (newContext != context)
    {
      NotificationChain msgs = null;
      if (context != null)
        msgs = ((InternalEObject)context).eInverseRemove(this, VOCLModel4Package.CONTEXT__CONSTRAINT, Context.class, msgs);
      if (newContext != null)
        msgs = ((InternalEObject)newContext).eInverseAdd(this, VOCLModel4Package.CONTEXT__CONSTRAINT, Context.class, msgs);
      msgs = basicSetContext(newContext, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModel4Package.CONSTRAINT__CONTEXT, newContext, newContext));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VOCLDiagramm getVOCLDiagramm()
  {
    if (eContainerFeatureID != VOCLModel4Package.CONSTRAINT__VOCL_DIAGRAMM) return null;
    return (VOCLDiagramm)eContainer;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVOCLDiagramm(VOCLDiagramm newVOCLDiagramm)
  {
    if (newVOCLDiagramm != eContainer || (eContainerFeatureID != VOCLModel4Package.CONSTRAINT__VOCL_DIAGRAMM && newVOCLDiagramm != null))
    {
      if (EcoreUtil.isAncestor(this, newVOCLDiagramm))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eContainer != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newVOCLDiagramm != null)
        msgs = ((InternalEObject)newVOCLDiagramm).eInverseAdd(this, VOCLModel4Package.VOCL_DIAGRAMM__CONSTRAINT, VOCLDiagramm.class, msgs);
      msgs = eBasicSetContainer((InternalEObject)newVOCLDiagramm, VOCLModel4Package.CONSTRAINT__VOCL_DIAGRAMM, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModel4Package.CONSTRAINT__VOCL_DIAGRAMM, newVOCLDiagramm, newVOCLDiagramm));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VOCLExpression getVOCLExpression()
  {
    return vOCLExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetVOCLExpression(VOCLExpression newVOCLExpression, NotificationChain msgs)
  {
    VOCLExpression oldVOCLExpression = vOCLExpression;
    vOCLExpression = newVOCLExpression;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, VOCLModel4Package.CONSTRAINT__VOCL_EXPRESSION, oldVOCLExpression, newVOCLExpression);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVOCLExpression(VOCLExpression newVOCLExpression)
  {
    if (newVOCLExpression != vOCLExpression)
    {
      NotificationChain msgs = null;
      if (vOCLExpression != null)
        msgs = ((InternalEObject)vOCLExpression).eInverseRemove(this, VOCLModel4Package.VOCL_EXPRESSION__CONSTRAINT, VOCLExpression.class, msgs);
      if (newVOCLExpression != null)
        msgs = ((InternalEObject)newVOCLExpression).eInverseAdd(this, VOCLModel4Package.VOCL_EXPRESSION__CONSTRAINT, VOCLExpression.class, msgs);
      msgs = basicSetVOCLExpression(newVOCLExpression, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModel4Package.CONSTRAINT__VOCL_EXPRESSION, newVOCLExpression, newVOCLExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList getVariableDeclaration()
  {
    if (variableDeclaration == null)
    {
      variableDeclaration = new EObjectContainmentEList(VariableDeclaration.class, this, VOCLModel4Package.CONSTRAINT__VARIABLE_DECLARATION);
    }
    return variableDeclaration;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
  {
    if (featureID >= 0)
    {
      switch (eDerivedStructuralFeatureID(featureID, baseClass))
      {
        case VOCLModel4Package.CONSTRAINT__CONSTRAINT:
          if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
          return eBasicSetContainer(otherEnd, VOCLModel4Package.CONSTRAINT__CONSTRAINT, msgs);
        case VOCLModel4Package.CONSTRAINT__CONTEXT:
          if (context != null)
            msgs = ((InternalEObject)context).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - VOCLModel4Package.CONSTRAINT__CONTEXT, null, msgs);
          return basicSetContext((Context)otherEnd, msgs);
        case VOCLModel4Package.CONSTRAINT__VOCL_DIAGRAMM:
          if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
          return eBasicSetContainer(otherEnd, VOCLModel4Package.CONSTRAINT__VOCL_DIAGRAMM, msgs);
        case VOCLModel4Package.CONSTRAINT__VOCL_EXPRESSION:
          if (vOCLExpression != null)
            msgs = ((InternalEObject)vOCLExpression).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - VOCLModel4Package.CONSTRAINT__VOCL_EXPRESSION, null, msgs);
          return basicSetVOCLExpression((VOCLExpression)otherEnd, msgs);
        default:
          return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
      }
    }
    if (eContainer != null)
      msgs = eBasicRemoveFromContainer(msgs);
    return eBasicSetContainer(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
  {
    if (featureID >= 0)
    {
      switch (eDerivedStructuralFeatureID(featureID, baseClass))
      {
        case VOCLModel4Package.CONSTRAINT__CONSTRAINT:
          return eBasicSetContainer(null, VOCLModel4Package.CONSTRAINT__CONSTRAINT, msgs);
        case VOCLModel4Package.CONSTRAINT__CONTEXT:
          return basicSetContext(null, msgs);
        case VOCLModel4Package.CONSTRAINT__VOCL_DIAGRAMM:
          return eBasicSetContainer(null, VOCLModel4Package.CONSTRAINT__VOCL_DIAGRAMM, msgs);
        case VOCLModel4Package.CONSTRAINT__VOCL_EXPRESSION:
          return basicSetVOCLExpression(null, msgs);
        case VOCLModel4Package.CONSTRAINT__VARIABLE_DECLARATION:
          return ((InternalEList)getVariableDeclaration()).basicRemove(otherEnd, msgs);
        default:
          return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
      }
    }
    return eBasicSetContainer(null, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs)
  {
    if (eContainerFeatureID >= 0)
    {
      switch (eContainerFeatureID)
      {
        case VOCLModel4Package.CONSTRAINT__CONSTRAINT:
          return ((InternalEObject)eContainer).eInverseRemove(this, VOCLModel4Package.CONSTRAINT__VOCL_EXPRESSION, Constraint.class, msgs);
        case VOCLModel4Package.CONSTRAINT__VOCL_DIAGRAMM:
          return ((InternalEObject)eContainer).eInverseRemove(this, VOCLModel4Package.VOCL_DIAGRAMM__CONSTRAINT, VOCLDiagramm.class, msgs);
        default:
          return eDynamicBasicRemoveFromContainer(msgs);
      }
    }
    return ((InternalEObject)eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object eGet(EStructuralFeature eFeature, boolean resolve)
  {
    switch (eDerivedStructuralFeatureID(eFeature))
    {
      case VOCLModel4Package.CONSTRAINT__NAME:
        return getName();
      case VOCLModel4Package.CONSTRAINT__EXPTYPE:
        return getExptype();
      case VOCLModel4Package.CONSTRAINT__IS_NEGATED:
        return isIsNegated() ? Boolean.TRUE : Boolean.FALSE;
      case VOCLModel4Package.CONSTRAINT__CONSTRAINT:
        return getConstraint();
      case VOCLModel4Package.CONSTRAINT__X:
        return new Integer(getX());
      case VOCLModel4Package.CONSTRAINT__Y:
        return new Integer(getY());
      case VOCLModel4Package.CONSTRAINT__WIDTH:
        return new Integer(getWidth());
      case VOCLModel4Package.CONSTRAINT__HEIGHT:
        return new Integer(getHeight());
      case VOCLModel4Package.CONSTRAINT__KIND:
        return getKind();
      case VOCLModel4Package.CONSTRAINT__CONTEXT:
        return getContext();
      case VOCLModel4Package.CONSTRAINT__VOCL_DIAGRAMM:
        return getVOCLDiagramm();
      case VOCLModel4Package.CONSTRAINT__VOCL_EXPRESSION:
        return getVOCLExpression();
      case VOCLModel4Package.CONSTRAINT__VARIABLE_DECLARATION:
        return getVariableDeclaration();
    }
    return eDynamicGet(eFeature, resolve);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void eSet(EStructuralFeature eFeature, Object newValue)
  {
    switch (eDerivedStructuralFeatureID(eFeature))
    {
      case VOCLModel4Package.CONSTRAINT__NAME:
        setName((String)newValue);
        return;
      case VOCLModel4Package.CONSTRAINT__EXPTYPE:
        setExptype((ExpressionType)newValue);
        return;
      case VOCLModel4Package.CONSTRAINT__IS_NEGATED:
        setIsNegated(((Boolean)newValue).booleanValue());
        return;
      case VOCLModel4Package.CONSTRAINT__CONSTRAINT:
        setConstraint((Constraint)newValue);
        return;
      case VOCLModel4Package.CONSTRAINT__X:
        setX(((Integer)newValue).intValue());
        return;
      case VOCLModel4Package.CONSTRAINT__Y:
        setY(((Integer)newValue).intValue());
        return;
      case VOCLModel4Package.CONSTRAINT__WIDTH:
        setWidth(((Integer)newValue).intValue());
        return;
      case VOCLModel4Package.CONSTRAINT__HEIGHT:
        setHeight(((Integer)newValue).intValue());
        return;
      case VOCLModel4Package.CONSTRAINT__KIND:
        setKind((Kind)newValue);
        return;
      case VOCLModel4Package.CONSTRAINT__CONTEXT:
        setContext((Context)newValue);
        return;
      case VOCLModel4Package.CONSTRAINT__VOCL_DIAGRAMM:
        setVOCLDiagramm((VOCLDiagramm)newValue);
        return;
      case VOCLModel4Package.CONSTRAINT__VOCL_EXPRESSION:
        setVOCLExpression((VOCLExpression)newValue);
        return;
      case VOCLModel4Package.CONSTRAINT__VARIABLE_DECLARATION:
        getVariableDeclaration().clear();
        getVariableDeclaration().addAll((Collection)newValue);
        return;
    }
    eDynamicSet(eFeature, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void eUnset(EStructuralFeature eFeature)
  {
    switch (eDerivedStructuralFeatureID(eFeature))
    {
      case VOCLModel4Package.CONSTRAINT__NAME:
        setName(NAME_EDEFAULT);
        return;
      case VOCLModel4Package.CONSTRAINT__EXPTYPE:
        setExptype(EXPTYPE_EDEFAULT);
        return;
      case VOCLModel4Package.CONSTRAINT__IS_NEGATED:
        setIsNegated(IS_NEGATED_EDEFAULT);
        return;
      case VOCLModel4Package.CONSTRAINT__CONSTRAINT:
        setConstraint((Constraint)null);
        return;
      case VOCLModel4Package.CONSTRAINT__X:
        setX(X_EDEFAULT);
        return;
      case VOCLModel4Package.CONSTRAINT__Y:
        setY(Y_EDEFAULT);
        return;
      case VOCLModel4Package.CONSTRAINT__WIDTH:
        setWidth(WIDTH_EDEFAULT);
        return;
      case VOCLModel4Package.CONSTRAINT__HEIGHT:
        setHeight(HEIGHT_EDEFAULT);
        return;
      case VOCLModel4Package.CONSTRAINT__KIND:
        setKind(KIND_EDEFAULT);
        return;
      case VOCLModel4Package.CONSTRAINT__CONTEXT:
        setContext((Context)null);
        return;
      case VOCLModel4Package.CONSTRAINT__VOCL_DIAGRAMM:
        setVOCLDiagramm((VOCLDiagramm)null);
        return;
      case VOCLModel4Package.CONSTRAINT__VOCL_EXPRESSION:
        setVOCLExpression((VOCLExpression)null);
        return;
      case VOCLModel4Package.CONSTRAINT__VARIABLE_DECLARATION:
        getVariableDeclaration().clear();
        return;
    }
    eDynamicUnset(eFeature);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean eIsSet(EStructuralFeature eFeature)
  {
    switch (eDerivedStructuralFeatureID(eFeature))
    {
      case VOCLModel4Package.CONSTRAINT__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case VOCLModel4Package.CONSTRAINT__EXPTYPE:
        return exptype != EXPTYPE_EDEFAULT;
      case VOCLModel4Package.CONSTRAINT__IS_NEGATED:
        return isNegated != IS_NEGATED_EDEFAULT;
      case VOCLModel4Package.CONSTRAINT__CONSTRAINT:
        return getConstraint() != null;
      case VOCLModel4Package.CONSTRAINT__X:
        return x != X_EDEFAULT;
      case VOCLModel4Package.CONSTRAINT__Y:
        return y != Y_EDEFAULT;
      case VOCLModel4Package.CONSTRAINT__WIDTH:
        return width != WIDTH_EDEFAULT;
      case VOCLModel4Package.CONSTRAINT__HEIGHT:
        return height != HEIGHT_EDEFAULT;
      case VOCLModel4Package.CONSTRAINT__KIND:
        return kind != KIND_EDEFAULT;
      case VOCLModel4Package.CONSTRAINT__CONTEXT:
        return context != null;
      case VOCLModel4Package.CONSTRAINT__VOCL_DIAGRAMM:
        return getVOCLDiagramm() != null;
      case VOCLModel4Package.CONSTRAINT__VOCL_EXPRESSION:
        return vOCLExpression != null;
      case VOCLModel4Package.CONSTRAINT__VARIABLE_DECLARATION:
        return variableDeclaration != null && !variableDeclaration.isEmpty();
    }
    return eDynamicIsSet(eFeature);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class baseClass)
  {
    if (baseClass == VOCLExpression.class)
    {
      switch (derivedFeatureID)
      {
        case VOCLModel4Package.CONSTRAINT__EXPTYPE: return VOCLModel4Package.VOCL_EXPRESSION__EXPTYPE;
        case VOCLModel4Package.CONSTRAINT__IS_NEGATED: return VOCLModel4Package.VOCL_EXPRESSION__IS_NEGATED;
        case VOCLModel4Package.CONSTRAINT__CONSTRAINT: return VOCLModel4Package.VOCL_EXPRESSION__CONSTRAINT;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class baseClass)
  {
    if (baseClass == VOCLExpression.class)
    {
      switch (baseFeatureID)
      {
        case VOCLModel4Package.VOCL_EXPRESSION__EXPTYPE: return VOCLModel4Package.CONSTRAINT__EXPTYPE;
        case VOCLModel4Package.VOCL_EXPRESSION__IS_NEGATED: return VOCLModel4Package.CONSTRAINT__IS_NEGATED;
        case VOCLModel4Package.VOCL_EXPRESSION__CONSTRAINT: return VOCLModel4Package.CONSTRAINT__CONSTRAINT;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (exptype: ");
    result.append(exptype);
    result.append(", isNegated: ");
    result.append(isNegated);
    result.append(", x: ");
    result.append(x);
    result.append(", y: ");
    result.append(y);
    result.append(", width: ");
    result.append(width);
    result.append(", height: ");
    result.append(height);
    result.append(", kind: ");
    result.append(kind);
    result.append(')');
    return result.toString();
  }

} //ConstraintImpl
