package de.tuberlin.tfs.ocl.metamodel.converter;

public class OclConverter {

	/** debug flag
	 */
	protected static boolean debug = false;
	public static final String version = "1.0";

	/** Converter warning messages
	 * @param warning string
	 */
        public static void warning (String warnStr) {
		if (debug) System.out.println ("* converter warning: " + warnStr + " *");
	}

	/** Converter messages
	 * @param message string
	 */
	public static void message (String msgStr) {
		if (debug) System.out.println (msgStr);
	}

	/** Set debug mode
	 * @param debug switch
	 */
	public static void setDebugMode (boolean debugMode) {
		System.out.println("* debug mode " + (debugMode ? "ON *" : "OFF *") );
		debug = debugMode;
	}

	
	public static void checkAttribute(Object obj, String objStr, Object parentObj)
	  throws NoSuchAttributeException {

		if (obj == null)
			throw new NoSuchAttributeException(objStr, obj);

	}

}
