package de.tuberlin.tfs.ocl.metamodel.expressions;

// import java.util.*;
// import de.tuberlin.tfs.ocl.metamodel.types.*;
import de.tuberlin.tfs.ocl.metamodel.converter.*;
import ru.novosoft.uml.foundation.core.*;
// import ru.novosoft.uml.foundation.data_types.*;
// import ru.novosoft.uml.behavior.common_behavior.*;


public class MEnumLiteralExpImpl extends MLiteralExpImpl implements MEnumLiteralExp {

	protected MModelElement referredEnumLiteral;


	/** Getter for property referredEnumLiteral.
	 * @return Value of property referredEnumLiteral.
	 */
	public MModelElement getReferredEnumLiteral() {
		return referredEnumLiteral;
	}

	/** Setter for property referredEnumLiteral.
	 * @param referredEnumLiteral value of property referredEnumLiteral.
	 */
	public void  setReferredEnumLiteral(MModelElement referredEnumLiteral) {
		this.referredEnumLiteral = referredEnumLiteral;
	}



	public String convert2OclString () throws NoSuchAttributeException {
		OclConverter.message("<MEnumLiteralExp>");
		
		OclConverter.checkAttribute(referredEnumLiteral, "enumeration literal", this);
		OclConverter.checkAttribute(referredEnumLiteral.getName(), 
		  "name of enumeration literal", this);

		String str = "#" + referredEnumLiteral.getName();
		
		OclConverter.message("</MEnumLiteralExp>");
		return str;
	}

}
