package de.tuberlin.tfs.ocl.metamodel.expressions;

// import java.util.*;
// import de.tuberlin.tfs.ocl.metamodel.types.*;
import de.tuberlin.tfs.ocl.metamodel.converter.*;
import ru.novosoft.uml.foundation.core.*;
// import ru.novosoft.uml.foundation.data_types.*;
// import ru.novosoft.uml.behavior.common_behavior.*;


public class MVariableDeclarationImpl implements MVariableDeclaration {

	protected String varname;
	protected MOclExpression initExpression;
	protected MClassifier type;


	/** Getter for property varname.
	 * @return Value of property varname.
	 */
	public String getVarname() {
		return varname;
	}

	/** Setter for property varname.
	 * @param varname value of property varname.
	 */
	public void  setVarname(String varname) {
		this.varname = varname;
	}

	/** Getter for property initExpression.
	 * @return Value of property initExpression.
	 */
	public MOclExpression getInitExpression() {
		return initExpression;
	}

	/** Setter for property initExpression.
	 * @param initExpression value of property initExpression.
	 */
	public void  setInitExpression(MOclExpression initExpression) {
		this.initExpression = initExpression;
	}

	/** Getter for property type.
	 * @return Value of property type.
	 */
	public MClassifier getType() {
		return type;
	}

	/** Setter for property type.
	 * @param type value of property type.
	 */
	public void  setType(MClassifier type) {
		this.type = type;
	}



	public String convert2OclString () throws NoSuchAttributeException {
		OclConverter.message("<MVariableDeclaration>");

		StringBuffer strB = new StringBuffer();

		OclConverter.checkAttribute(varname, "variable name", this);

		strB.append(varname);

		if (initExpression != null) {
			strB.append(" = " + initExpression.convert2OclString() );
		}

		OclConverter.message("</MVariableDeclaration>");
		return strB.toString();
	}

}
