/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.dialogs;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.SWT;
import java.awt.Toolkit;
import java.awt.Dimension;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.MessageBox;

/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a
* for-profit company or business) then you should purchase
* a license - please visit www.cloudgarden.com for details.
*/
public class AddPartameterContextDialog extends org.eclipse.swt.widgets.Dialog {
	private Label label2;
	private Composite composite1;
	private Button applyAttribute;
	private Shell dialogShell;
	private Button button1;
	private Button applyParameter;
	private Composite buttons;
	private Text Name;
	private Label label1;
	private Label attName;
	private Combo attType;
	private Group attDescr;
	
	private boolean state = false;
	private String namestr  = "";
	private String type  = "";
	
	

	public AddPartameterContextDialog(Shell parent, int style) {
		super(parent, style);
	}
	
	public AddPartameterContextDialog(Shell parent) {
		super(parent);
	}
	
	public AddPartameterContextDialog(Shell parent, 
							  String name,  String type) {
		super(parent);
		this.namestr = name;
		this.type = type;
	}



	/** Auto-generated event handler method */
	protected void button1MouseDown(MouseEvent evt){
		namestr  = Name.getText();
		type  = attType.getText();
		if (isValidString(namestr,true)) {
			state = true;
		} else {
			// Show Error Dialog
			MessageBox msgb = new MessageBox(dialogShell,0);
			msgb.setText("Shit happens!");
			msgb.setMessage("Error in Parameter declaration");
			msgb.open();
		}
		dialogShell.close();
	}
	


	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			composite1 = new Composite(dialogShell,SWT.NULL);
			label2 = new Label(composite1,SWT.NULL);
			attDescr = new Group(dialogShell,SWT.NULL);
			attType = new Combo(attDescr,SWT.NULL);
			attName = new Label(attDescr,SWT.NULL);
			label1 = new Label(attDescr,SWT.NULL);
			Name = new Text(attDescr,SWT.BORDER);
			buttons = new Composite(dialogShell,SWT.NULL);
			applyAttribute = new Button(buttons,SWT.PUSH| SWT.CENTER);
			button1 = new Button(buttons,SWT.PUSH| SWT.CENTER);
	
			dialogShell.setText("add parameter");
			dialogShell.setSize(new org.eclipse.swt.graphics.Point(234,198));
	
			GridData composite1LData = new GridData();
			composite1LData.verticalAlignment = GridData.CENTER;
			composite1LData.horizontalAlignment = GridData.BEGINNING;
			composite1LData.widthHint = 238;
			composite1LData.heightHint = 44;
			composite1LData.horizontalIndent = 0;
			composite1LData.horizontalSpan = 1;
			composite1LData.verticalSpan = 1;
			composite1LData.grabExcessHorizontalSpace = false;
			composite1LData.grabExcessVerticalSpace = false;
			composite1.setLayoutData(composite1LData);
			composite1.setSize(new org.eclipse.swt.graphics.Point(238,44));
			final Color composite1background = new Color(Display.getDefault(),255,255,255);
			composite1.setBackground(composite1background);
	
			FormData label2LData = new FormData();
			label2LData.height = 45;
			label2LData.width = 228;
			label2LData.left =  new FormAttachment(2, 1000, 0);
			label2LData.right =  new FormAttachment(960, 1000, 0);
			label2LData.top =  new FormAttachment(-11, 1000, 0);
			label2LData.bottom =  new FormAttachment(1034, 1000, 0);
			label2.setLayoutData(label2LData);
			label2.setText("label2");
			final org.eclipse.swt.graphics.Image label2image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/workbench.gif"));
			label2image.setBackground(label2.getBackground());
			label2.setImage(label2image);
			label2.setSize(new org.eclipse.swt.graphics.Point(228,45));
			FormLayout composite1Layout = new FormLayout();
			composite1.setLayout(composite1Layout);
			composite1Layout.marginWidth = 0;
			composite1Layout.marginHeight = 0;
			composite1.layout();
	
			GridData attDescrLData = new GridData();
			attDescrLData.verticalAlignment = GridData.CENTER;
			attDescrLData.horizontalAlignment = GridData.BEGINNING;
			attDescrLData.widthHint = 217;
			attDescrLData.heightHint = 87;
			attDescrLData.horizontalIndent = 0;
			attDescrLData.horizontalSpan = 1;
			attDescrLData.verticalSpan = 1;
			attDescrLData.grabExcessHorizontalSpace = false;
			attDescrLData.grabExcessVerticalSpace = false;
			attDescr.setLayoutData(attDescrLData);
			attDescr.setText("Parameter Description");
			attDescr.setSize(new org.eclipse.swt.graphics.Point(217,87));
			final Font attDescrfont = new Font(Display.getDefault(),"Courier New",8,0);
			attDescr.setFont(attDescrfont);
	
			FormData attTypeLData = new FormData();
			attTypeLData.height = 27;
			attTypeLData.width = 121;
			attTypeLData.left =  new FormAttachment(269, 1000, 0);
			attTypeLData.right =  new FormAttachment(942, 1000, 0);
			attTypeLData.top =  new FormAttachment(406, 1000, 0);
			attTypeLData.bottom =  new FormAttachment(557, 1000, 0);
			attType.setLayoutData(attTypeLData);
			attType.setSize(new org.eclipse.swt.graphics.Point(121,27));
			final Font attTypefont = new Font(Display.getDefault(),"Courier New",10,0);
			attType.setFont(attTypefont);
	
			FormData attNameLData = new FormData();
			attNameLData.height = 18;
			attNameLData.width = 45;
			attNameLData.left =  new FormAttachment(20, 1000, 0);
			attNameLData.right =  new FormAttachment(228, 1000, 0);
			attNameLData.top =  new FormAttachment(406, 1000, 0);
			attNameLData.bottom =  new FormAttachment(615, 1000, 0);
			attName.setLayoutData(attNameLData);
			attName.setText("Type:");
			attName.setSize(new org.eclipse.swt.graphics.Point(45,18));
			final Font attNamefont = new Font(Display.getDefault(),"Courier New",12,1);
			attName.setFont(attNamefont);
	
			FormData label1LData = new FormData();
			label1LData.height = 19;
			label1LData.width = 49;
			label1LData.left =  new FormAttachment(16, 1000, 0);
			label1LData.right =  new FormAttachment(241, 1000, 0);
			label1LData.top =  new FormAttachment(90, 1000, 0);
			label1LData.bottom =  new FormAttachment(303, 1000, 0);
			label1.setLayoutData(label1LData);
			label1.setText("Name:");
			label1.setSize(new org.eclipse.swt.graphics.Point(49,19));
			label1.setFont(attNamefont);
	
			FormData NameLData = new FormData();
			NameLData.height = 14;
			NameLData.width = 139;
			NameLData.left =  new FormAttachment(269, 1000, 0);
			NameLData.right =  new FormAttachment(942, 1000, 0);
			NameLData.top =  new FormAttachment(111, 1000, 0);
			NameLData.bottom =  new FormAttachment(358, 1000, 0);
			Name.setLayoutData(NameLData);
			Name.setFont(attTypefont);
			Name.setSize(new org.eclipse.swt.graphics.Point(139,15));
			FormLayout attDescrLayout = new FormLayout();
			attDescr.setLayout(attDescrLayout);
			attDescrLayout.marginWidth = 0;
			attDescrLayout.marginHeight = 0;
			attDescr.layout();
	
			GridData buttonsLData = new GridData();
			buttonsLData.verticalAlignment = GridData.CENTER;
			buttonsLData.horizontalAlignment = GridData.BEGINNING;
			buttonsLData.widthHint = 222;
			buttonsLData.heightHint = 51;
			buttonsLData.horizontalIndent = 0;
			buttonsLData.horizontalSpan = 1;
			buttonsLData.verticalSpan = 1;
			buttonsLData.grabExcessHorizontalSpace = false;
			buttonsLData.grabExcessVerticalSpace = false;
			buttons.setLayoutData(buttonsLData);
			buttons.setSize(new org.eclipse.swt.graphics.Point(222,51));
	
			FormData applyAttributeLData = new FormData();
			applyAttributeLData.height = 20;
			applyAttributeLData.width = 80;
			applyAttributeLData.left =  new FormAttachment(587, 1000, 0);
			applyAttributeLData.right =  new FormAttachment(948, 1000, 0);
			applyAttributeLData.top =  new FormAttachment(205, 1000, 0);
			applyAttributeLData.bottom =  new FormAttachment(598, 1000, 0);
			applyAttribute.setLayoutData(applyAttributeLData);
			applyAttribute.setText("CANCEL");
			applyAttribute.setSize(new org.eclipse.swt.graphics.Point(80,20));
			final Font applyAttributefont = new Font(Display.getDefault(),"Courier New",8,1);
			applyAttribute.setFont(applyAttributefont);
			applyAttribute.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					applyAttributeMouseDown(evt);
				}
			});
	
			FormData button1LData = new FormData();
			button1LData.height = 20;
			button1LData.width = 80;
			button1LData.left =  new FormAttachment(51, 1000, 0);
			button1LData.right =  new FormAttachment(412, 1000, 0);
			button1LData.top =  new FormAttachment(205, 1000, 0);
			button1LData.bottom =  new FormAttachment(598, 1000, 0);
			button1.setLayoutData(button1LData);
			button1.setText("APPLY");
			button1.setSize(new org.eclipse.swt.graphics.Point(80,20));
			button1.setFont(applyAttributefont);
			button1.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					button1MouseDown(evt);
				}
			});
			FormLayout buttonsLayout = new FormLayout();
			buttons.setLayout(buttonsLayout);
			buttonsLayout.marginWidth = 0;
			buttonsLayout.marginHeight = 0;
			buttons.layout();
			GridLayout dialogShellLayout = new GridLayout(1, true);
			dialogShell.setLayout(dialogShellLayout);
			dialogShellLayout.marginWidth = 5;
			dialogShellLayout.marginHeight = 5;
			dialogShellLayout.numColumns = 1;
			dialogShellLayout.makeColumnsEqualWidth = true;
			dialogShellLayout.horizontalSpacing = 5;
			dialogShellLayout.verticalSpacing = 5;
			dialogShell.layout();
			dialogShell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					composite1background.dispose();
					label2image.dispose();
					attDescrfont.dispose();
					attTypefont.dispose();
					attNamefont.dispose();
					applyAttributefont.dispose();
				}
			});
			Rectangle bounds = dialogShell.computeTrim(0, 0, 234,198);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI(){
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI(){
		attType.add("String");
		attType.add("Integer");
		attType.add("Boolean");
		attType.add("Double");
		attType.add("Short");
		attType.add("Byte");
		
		this.setParameterValues(namestr,type);
		
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		int x = (int)dim.getWidth();
		int y = (int)dim.getHeight();
		x = x/2 - (dialogShell.getSize().x/2);
		y = y/2 - (dialogShell.getSize().y/2);
		dialogShell.setLocation(x,y);
		
		// add a name to the dialogShell
		dialogShell.setText("Change Attribute Values");
		
		// change the TabList
		Control[] con = {Name,attType};
		attDescr.setTabList(con);
		
		Control[] con2 = {button1,applyParameter};
		//buttons.setTabList(con2);
		
	}

	/**
	 * Methods for retrieving the Values 
	 * from the Text-Fields/Combo-Box
	 */
	public String getParameterName() {
		return namestr;
	}
	

	
	public String getParameterType() {
		return type;
	}
	/**
	 * @return - if apply is selected
	 */
	public boolean isState() {
		return state;
	}
	
	/**
	 * This method is for adding Values into the 
	 * Textfields, used for edititng an attribute
	 * @param name - String value of the name
	 * @param value - String value of the value
	 * @param type - String value of the type
	 */
	public void setParameterValues(String namestr, String type) {
		this.namestr = namestr;
		Name.setText(namestr);
		this.type = type;
		attType.setText(type);
	}
	
	/**
	 * This method checks if the String given is not null,
	 * not "", consists of no Space-Characters and looks fine overall:
	 * for name=true, there are only normal characters allowed
	 **/
	private boolean isValidString(String str, boolean name) {
		if (str == null) return false;
		if (str.length() == 0) return false;
		if (name) {
			if (str.indexOf(" ") >= 0) return false;
		}
		return true;	
		
	}

	/** Auto-generated main method */
	public static void main(String[] args){
		showGUI();
	}

	/**
	* This static method creates a new instance of this class and shows
	* it inside a new Shell.
	*
	* It is a convenience method for showing the GUI, but it can be
	* copied and used as a basis for your own code.	*
	* It is auto-generated code - the body of this method will be
	* re-generated after any changes are made to the GUI.
	* However, if you delete this method it will not be re-created.	*/
	public static void showGUI(){
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			AddPartameterContextDialog inst = new AddPartameterContextDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Auto-generated event handler method */
	protected void applyAttributeMouseDown(MouseEvent evt){
		dialogShell.close();
	}
}
