/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.dialogs;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.SWT;

/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a
* for-profit company or business) then you should purchase
* a license - please visit www.cloudgarden.com for details.
*/
public class CreateAssociationDialog extends org.eclipse.swt.widgets.Dialog {
	private Canvas canvas1;
	private Label label2;
	private Label label1;
	private Label prop;
	private Button cancel;
	private Button enter;
	private Composite composite2;
	private Label namesrcLb;
	private Label nametarLb;
	private Label targetLb;
	private Text navNameSource;
	private Text navNameTarget;
	private Label sourceLb;
	private Button nav2;
	private Button nav1;
	private Group group1;
	private Label ass;
	private Composite composite1;
	private Shell dialogShell;
	private boolean state;
	private String sname;
	private String tname;
	private String NavNameS;
	private String NavNameT;
	final Image decoration = new Image(Display.getDefault(),
							CreateAssociationDialog.class.getResourceAsStream("fig/deco.GIF"));

	public CreateAssociationDialog(Shell parent, int style) {
		super(parent, style);
	}
	
	public CreateAssociationDialog(Shell parent) {
		super(parent);
	}
	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			composite1 = new Composite(dialogShell,SWT.NULL);
			label2 = new Label(composite1,SWT.NULL);
			label1 = new Label(composite1,SWT.NULL);
			prop = new Label(composite1,SWT.NULL);
			ass = new Label(composite1,SWT.NULL);
			group1 = new Group(dialogShell,SWT.NULL);
			canvas1 = new Canvas(group1,SWT.NULL);
			namesrcLb = new Label(group1,SWT.NULL);
			nametarLb = new Label(group1,SWT.NULL);
			targetLb = new Label(group1,SWT.NULL);
			navNameSource = new Text(group1,SWT.BORDER);
			navNameTarget = new Text(group1,SWT.BORDER);
			nav1 = new Button(group1,SWT.RADIO| SWT.LEFT);
			nav2 = new Button(group1,SWT.RADIO| SWT.LEFT);
			sourceLb = new Label(group1,SWT.NULL);
			composite2 = new Composite(dialogShell,SWT.NULL);
			cancel = new Button(composite2,SWT.PUSH| SWT.CENTER);
			enter = new Button(composite2,SWT.PUSH| SWT.CENTER);
	
			dialogShell.setSize(new org.eclipse.swt.graphics.Point(490,279));
	
			GridData composite1LData = new GridData();
			composite1LData.verticalAlignment = GridData.CENTER;
			composite1LData.horizontalAlignment = GridData.BEGINNING;
			composite1LData.widthHint = 480;
			composite1LData.heightHint = 55;
			composite1LData.horizontalIndent = 0;
			composite1LData.horizontalSpan = 1;
			composite1LData.verticalSpan = 1;
			composite1LData.grabExcessHorizontalSpace = false;
			composite1LData.grabExcessVerticalSpace = false;
			composite1.setLayoutData(composite1LData);
			composite1.setSize(new org.eclipse.swt.graphics.Point(480,55));
			final Color composite1background = new Color(Display.getDefault(),255,255,255);
			composite1.setBackground(composite1background);
	
			FormData label2LData = new FormData();
			label2LData.height = 46;
			label2LData.width = 62;
			label2LData.left =  new FormAttachment(13, 1000, 0);
			label2LData.right =  new FormAttachment(142, 1000, 0);
			label2LData.top =  new FormAttachment(81, 1000, 0);
			label2LData.bottom =  new FormAttachment(918, 1000, 0);
			label2.setLayoutData(label2LData);
			label2.setText("label2");
			final org.eclipse.swt.graphics.Image label2image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newEEnum_wizR.GIF"));
			label2image.setBackground(label2.getBackground());
			label2.setImage(label2image);
			label2.setSize(new org.eclipse.swt.graphics.Point(62,46));
	
			FormData label1LData = new FormData();
			label1LData.height = 51;
			label1LData.width = 76;
			label1LData.left =  new FormAttachment(832, 1000, 0);
			label1LData.right =  new FormAttachment(990, 1000, 0);
			label1LData.top =  new FormAttachment(63, 1000, 0);
			label1LData.bottom =  new FormAttachment(990, 1000, 0);
			label1.setLayoutData(label1LData);
			label1.setText("label1");
			final org.eclipse.swt.graphics.Image label1image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/activity_diagram_wiz.gif"));
			label1image.setBackground(label1.getBackground());
			label1.setImage(label1image);
			label1.setSize(new org.eclipse.swt.graphics.Point(76,51));
	
			FormData propLData = new FormData();
			propLData.height = 18;
			propLData.width = 79;
			propLData.left =  new FormAttachment(526, 1000, 0);
			propLData.right =  new FormAttachment(690, 1000, 0);
			propLData.top =  new FormAttachment(590, 1000, 0);
			propLData.bottom =  new FormAttachment(918, 1000, 0);
			prop.setLayoutData(propLData);
			prop.setText("property");
			prop.setSize(new org.eclipse.swt.graphics.Point(79,18));
			prop.setBackground(composite1background);
			final Font propfont = new Font(Display.getDefault(),"Courier New",12,0);
			prop.setFont(propfont);
	
			FormData assLData = new FormData();
			assLData.height = 19;
			assLData.width = 117;
			assLData.left =  new FormAttachment(246, 1000, 0);
			assLData.right =  new FormAttachment(490, 1000, 0);
			assLData.top =  new FormAttachment(172, 1000, 0);
			assLData.bottom =  new FormAttachment(518, 1000, 0);
			ass.setLayoutData(assLData);
			ass.setText("Association");
			ass.setSize(new org.eclipse.swt.graphics.Point(117,19));
			ass.setBackground(composite1background);
			final Font assfont = new Font(Display.getDefault(),"Courier New",12,1);
			ass.setFont(assfont);
			FormLayout composite1Layout = new FormLayout();
			composite1.setLayout(composite1Layout);
			composite1Layout.marginWidth = 0;
			composite1Layout.marginHeight = 0;
			composite1.layout();
	
			GridData group1LData = new GridData();
			group1LData.verticalAlignment = GridData.CENTER;
			group1LData.horizontalAlignment = GridData.BEGINNING;
			group1LData.widthHint = 474;
			group1LData.heightHint = 149;
			group1LData.horizontalIndent = 0;
			group1LData.horizontalSpan = 1;
			group1LData.verticalSpan = 1;
			group1LData.grabExcessHorizontalSpace = false;
			group1LData.grabExcessVerticalSpace = false;
			group1.setLayoutData(group1LData);
			group1.setSize(new org.eclipse.swt.graphics.Point(474,149));
			group1.setEnabled(true);
			final Font group1font = new Font(Display.getDefault(),"Tahoma",11,1);
			group1.setFont(group1font);
	
			FormData canvas1LData = new FormData();
			canvas1LData.height = 134;
			canvas1LData.width = 4;
			canvas1LData.left =  new FormAttachment(492, 1000, 0);
			canvas1LData.right =  new FormAttachment(501, 1000, 0);
			canvas1LData.top =  new FormAttachment(3, 1000, 0);
			canvas1LData.bottom =  new FormAttachment(902, 1000, 0);
			canvas1.setLayoutData(canvas1LData);
			canvas1.setSize(new org.eclipse.swt.graphics.Point(4,134));
			final Color canvas1background = new Color(Display.getDefault(),64,0,64);
			canvas1.setBackground(canvas1background);
	
			FormData namesrcLbLData = new FormData();
			namesrcLbLData.height = 23;
			namesrcLbLData.width = 45;
			namesrcLbLData.left =  new FormAttachment(5, 1000, 0);
			namesrcLbLData.right =  new FormAttachment(100, 1000, 0);
			namesrcLbLData.top =  new FormAttachment(562, 1000, 0);
			namesrcLbLData.bottom =  new FormAttachment(717, 1000, 0);
			namesrcLb.setLayoutData(namesrcLbLData);
			namesrcLb.setText("name:");
			namesrcLb.setSize(new org.eclipse.swt.graphics.Point(45,23));
			final Font namesrcLbfont = new Font(Display.getDefault(),"Courier New",10,0);
			namesrcLb.setFont(namesrcLbfont);
	
			FormData nametarLbLData = new FormData();
			nametarLbLData.height = 23;
			nametarLbLData.width = 45;
			nametarLbLData.left =  new FormAttachment(522, 1000, 0);
			nametarLbLData.right =  new FormAttachment(617, 1000, 0);
			nametarLbLData.top =  new FormAttachment(560, 1000, 0);
			nametarLbLData.bottom =  new FormAttachment(714, 1000, 0);
			nametarLb.setLayoutData(nametarLbLData);
			nametarLb.setText("name:");
			nametarLb.setSize(new org.eclipse.swt.graphics.Point(45,23));
			nametarLb.setFont(namesrcLbfont);
	
			FormData targetLbLData = new FormData();
			targetLbLData.height = 23;
			targetLbLData.width = 220;
			targetLbLData.left =  new FormAttachment(522, 1000, 0);
			targetLbLData.right =  new FormAttachment(986, 1000, 0);
			targetLbLData.top =  new FormAttachment(16, 1000, 0);
			targetLbLData.bottom =  new FormAttachment(171, 1000, 0);
			targetLb.setLayoutData(targetLbLData);
			targetLb.setText("target");
			targetLb.setSize(new org.eclipse.swt.graphics.Point(220,23));
			targetLb.setEnabled(true);
			targetLb.setFont(assfont);
	
			FormData navNameSourceLData = new FormData();
			navNameSourceLData.height = 18;
			navNameSourceLData.width = 213;
			navNameSourceLData.left =  new FormAttachment(5, 1000, 0);
			navNameSourceLData.right =  new FormAttachment(469, 1000, 0);
			navNameSourceLData.top =  new FormAttachment(714, 1000, 0);
			navNameSourceLData.bottom =  new FormAttachment(882, 1000, 0);
			navNameSource.setLayoutData(navNameSourceLData);
			navNameSource.setFont(namesrcLbfont);
			navNameSource.setSize(new org.eclipse.swt.graphics.Point(213,18));
			navNameSource.setBackground(composite1background);
	
			FormData navNameTargetLData = new FormData();
			navNameTargetLData.height = 18;
			navNameTargetLData.width = 213;
			navNameTargetLData.left =  new FormAttachment(522, 1000, 0);
			navNameTargetLData.right =  new FormAttachment(986, 1000, 0);
			navNameTargetLData.top =  new FormAttachment(714, 1000, 0);
			navNameTargetLData.bottom =  new FormAttachment(882, 1000, 0);
			navNameTarget.setLayoutData(navNameTargetLData);
			navNameTarget.setFont(namesrcLbfont);
			navNameTarget.setSize(new org.eclipse.swt.graphics.Point(213,18));
			navNameTarget.setBackground(composite1background);
			navNameTarget.setEnabled(false);
	
			FormData nav1LData = new FormData();
			nav1LData.height = 23;
			nav1LData.width = 125;
			nav1LData.left =  new FormAttachment(522, 1000, 0);
			nav1LData.right =  new FormAttachment(785, 1000, 0);
			nav1LData.top =  new FormAttachment(291, 1000, 0);
			nav1LData.bottom =  new FormAttachment(446, 1000, 0);
			nav1.setLayoutData(nav1LData);
			nav1.setText("navigate");
			nav1.setSize(new org.eclipse.swt.graphics.Point(125,23));
			final Font nav1font = new Font(Display.getDefault(),"Courier New",10,1);
			nav1.setFont(nav1font);
			nav1.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					nav1WidgetSelected(evt);
				}
			});
	
			FormData nav2LData = new FormData();
			nav2LData.height = 23;
			nav2LData.width = 125;
			nav2LData.left =  new FormAttachment(5, 1000, 0);
			nav2LData.right =  new FormAttachment(268, 1000, 0);
			nav2LData.top =  new FormAttachment(290, 1000, 0);
			nav2LData.bottom =  new FormAttachment(445, 1000, 0);
			nav2.setLayoutData(nav2LData);
			nav2.setSelection(true);
			nav2.setText("navigate");
			nav2.setSize(new org.eclipse.swt.graphics.Point(125,23));
			nav2.setEnabled(true);
			nav2.setFont(nav1font);
			nav2.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					nav2WidgetSelected(evt);
				}
			});
	
			FormData sourceLbLData = new FormData();
			sourceLbLData.height = 23;
			sourceLbLData.width = 220;
			sourceLbLData.left =  new FormAttachment(5, 1000, 0);
			sourceLbLData.right =  new FormAttachment(469, 1000, 0);
			sourceLbLData.top =  new FormAttachment(16, 1000, 0);
			sourceLbLData.bottom =  new FormAttachment(171, 1000, 0);
			sourceLb.setLayoutData(sourceLbLData);
			sourceLb.setText("source");
			sourceLb.setSize(new org.eclipse.swt.graphics.Point(220,23));
			sourceLb.setFont(assfont);
			FormLayout group1Layout = new FormLayout();
			group1.setLayout(group1Layout);
			group1Layout.marginWidth = 0;
			group1Layout.marginHeight = 0;
			group1.layout();
	
			GridData composite2LData = new GridData();
			composite2LData.verticalAlignment = GridData.CENTER;
			composite2LData.horizontalAlignment = GridData.BEGINNING;
			composite2LData.widthHint = 480;
			composite2LData.heightHint = 40;
			composite2LData.horizontalIndent = 0;
			composite2LData.horizontalSpan = 1;
			composite2LData.verticalSpan = 1;
			composite2LData.grabExcessHorizontalSpace = false;
			composite2LData.grabExcessVerticalSpace = false;
			composite2.setLayoutData(composite2LData);
			composite2.setSize(new org.eclipse.swt.graphics.Point(480,40));
	
			FormData cancelLData = new FormData();
			cancelLData.height = 25;
			cancelLData.width = 85;
			cancelLData.left =  new FormAttachment(792, 1000, 0);
			cancelLData.right =  new FormAttachment(969, 1000, 0);
			cancelLData.top =  new FormAttachment(137, 1000, 0);
			cancelLData.bottom =  new FormAttachment(762, 1000, 0);
			cancel.setLayoutData(cancelLData);
			cancel.setText("cancel");
			cancel.setSize(new org.eclipse.swt.graphics.Point(85,25));
			cancel.setFont(nav1font);
			cancel.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					cancelMouseDown(evt);
				}
			});
	
			FormData enterLData = new FormData();
			enterLData.height = 25;
			enterLData.width = 85;
			enterLData.left =  new FormAttachment(605, 1000, 0);
			enterLData.right =  new FormAttachment(782, 1000, 0);
			enterLData.top =  new FormAttachment(137, 1000, 0);
			enterLData.bottom =  new FormAttachment(762, 1000, 0);
			enter.setLayoutData(enterLData);
			enter.setText("enter");
			enter.setSize(new org.eclipse.swt.graphics.Point(85,25));
			enter.setFont(nav1font);
			enter.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					enterMouseDown(evt);
				}
			});
			FormLayout composite2Layout = new FormLayout();
			composite2.setLayout(composite2Layout);
			composite2Layout.marginWidth = 0;
			composite2Layout.marginHeight = 0;
			composite2.layout();
			GridLayout dialogShellLayout = new GridLayout(1, true);
			dialogShell.setLayout(dialogShellLayout);
			dialogShellLayout.marginWidth = 5;
			dialogShellLayout.marginHeight = 5;
			dialogShellLayout.numColumns = 1;
			dialogShellLayout.makeColumnsEqualWidth = true;
			dialogShellLayout.horizontalSpacing = 5;
			dialogShellLayout.verticalSpacing = 5;
			dialogShell.layout();
			dialogShell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					composite1background.dispose();
					label2image.dispose();
					label1image.dispose();
					propfont.dispose();
					assfont.dispose();
					group1font.dispose();
					canvas1background.dispose();
					namesrcLbfont.dispose();
					nav1font.dispose();
				}
			});
			Rectangle bounds = dialogShell.computeTrim(0, 0, 490,279);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI(){
		state=false;
		NavNameS=new String();
		NavNameT=new String();
	
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI(){
		sourceLb.setText(sname);
		targetLb.setText(tname);
	}

	/** Auto-generated main method */
	public static void main(String[] args){
		showGUI();
	}

	/**
	* This static method creates a new instance of this class and shows
	* it inside a new Shell.
	*
	* It is a convenience method for showing the GUI, but it can be
	* copied and used as a basis for your own code.	*
	* It is auto-generated code - the body of this method will be
	* re-generated after any changes are made to the GUI.
	* However, if you delete this method it will not be re-created.	*/
	public static void showGUI(){
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			CreateAssociationDialog inst = new CreateAssociationDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/**
	* This is an auto-generated method which you can alter,
	* e.g. to point to a different property file, to modify the key by
	* by prefixing the name of this class, etc.
	*
	* By default, it expects a file called "messages.properties" to exist in the
	* current package, and returns the value of the property defined
	* in that file for the given key
	*/
	public String getExternalizedString(String key){
		try {
			return java.util.ResourceBundle.getBundle("NavExpEditor.dialogs.CreateAssociationDialogMessages").getString(key);
		} catch (java.util.MissingResourceException e) {
			return '!' + key + '!';
		}
	}

	/** Auto-generated event handler method */
	protected void nav2WidgetSelected(SelectionEvent evt){
		if(nav2.getSelection()){
			navNameTarget.setText("");
			navNameTarget.setEnabled(false);
			navNameSource.setEnabled(true);
		}
	}

	/** Auto-generated event handler method */
	protected void nav1WidgetSelected(SelectionEvent evt){
		if(nav1.getSelection()){
			navNameSource.setText("");
			navNameTarget.setEnabled(true);
			navNameSource.setEnabled(false);
		}
	}
	
	public void setSourceName(String name){sname=name;}
	public void setTargetName(String name){tname=name;}
	
	public String getSourceNav(){return NavNameS;}
	public String getTargetNav(){return NavNameT;}

	/** Auto-generated event handler method */
	protected void enterMouseDown(MouseEvent evt){
		state=true;
		NavNameS=navNameSource.getText();
		NavNameT=navNameTarget.getText();
		dialogShell.close();
	}

	/** Auto-generated event handler method */
	protected void cancelMouseDown(MouseEvent evt){
		state=false;
		dialogShell.close();
	}
	/**
	 * @return
	 */
	public boolean isState() {
		return state;
	}

}
