/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.dialogs;

import java.util.LinkedList;
import java.util.List;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.SWT;

/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a
* for-profit company or business) then you should purchase
* a license - please visit www.cloudgarden.com for details.
*/
public class CreateConstraintDialog extends org.eclipse.swt.widgets.Dialog {
	private Label label2;
	private Label label1;
	private Label TypeOfContext;
	private Text TypeInv;
	private Button enterParameter;
	private Composite composite3;
	private Combo KindCMb;
	private Button Cancel;
	private Button Enter;
	private Text VarOfCon;
	private Label NameOfVar;
	private Text NameOfContextTxt;
	private Label NameOfContext;
	private Button IsClassifierB;
	private Label IsCclassifier;
	private Text NameTxt;
	private Text TypeTxt;
	private Label KindLb;
	private Label TypeLb;
	private Label NameLb;
	private Label TitelLb;
	private Group composite2;
	private Composite composite1;
	private Shell dialogShell;
	private static String strClassifier="context is a classifier!";
	private static String strMethod="context is a method!";
	
	
	//Var for create
	private String nameConstraint;
	private String nameContext;
	private String variable;
	private String typeC;
	private int kindC;
	private boolean isCl;
	private boolean state;
	private List parameter=new LinkedList();
	
	
	
	
	public CreateConstraintDialog(Shell parent, int style) {
		super(parent, style);
	}
	
	public CreateConstraintDialog(Shell parent) {
		super(parent);
	}
	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			composite1 = new Composite(dialogShell,SWT.NULL);
			label2 = new Label(composite1,SWT.NULL);
			label1 = new Label(composite1,SWT.NULL);
			TitelLb = new Label(composite1,SWT.NULL);
			TypeOfContext = new Label(composite1,SWT.NULL);
			composite2 = new Group(dialogShell,SWT.NO_RADIO_GROUP);
			TypeInv = new Text(composite2,SWT.BORDER);
			enterParameter = new Button(composite2,SWT.PUSH| SWT.CENTER);
			VarOfCon = new Text(composite2,SWT.BORDER);
			NameOfVar = new Label(composite2,SWT.NULL);
			NameOfContextTxt = new Text(composite2,SWT.BORDER);
			NameOfContext = new Label(composite2,SWT.NULL);
			IsClassifierB = new Button(composite2,SWT.CHECK| SWT.LEFT);
			IsCclassifier = new Label(composite2,SWT.NULL);
			NameTxt = new Text(composite2,SWT.BORDER);
			TypeTxt = new Text(composite2,SWT.BORDER);
			KindLb = new Label(composite2,SWT.NULL);
			KindCMb = new Combo(composite2,SWT.DROP_DOWN| SWT.READ_ONLY);
			TypeLb = new Label(composite2,SWT.NULL);
			NameLb = new Label(composite2,SWT.NULL);
			composite3 = new Composite(dialogShell,SWT.NULL);
			Cancel = new Button(composite3,SWT.PUSH| SWT.CENTER);
			Enter = new Button(composite3,SWT.PUSH| SWT.CENTER);
	
			dialogShell.setText("Create constraint");
			dialogShell.setSize(new org.eclipse.swt.graphics.Point(490,258));
	
			GridData composite1LData = new GridData();
			composite1LData.verticalAlignment = GridData.CENTER;
			composite1LData.horizontalAlignment = GridData.BEGINNING;
			composite1LData.widthHint = 483;
			composite1LData.heightHint = 57;
			composite1LData.horizontalIndent = 0;
			composite1LData.horizontalSpan = 1;
			composite1LData.verticalSpan = 1;
			composite1LData.grabExcessHorizontalSpace = false;
			composite1LData.grabExcessVerticalSpace = false;
			composite1.setLayoutData(composite1LData);
			composite1.setSize(new org.eclipse.swt.graphics.Point(483,57));
			final Color composite1background = new Color(Display.getDefault(),255,255,255);
			composite1.setBackground(composite1background);
	
			FormData label2LData = new FormData();
			label2LData.height = 51;
			label2LData.width = 58;
			label2LData.left =  new FormAttachment(9, 1000, 0);
			label2LData.right =  new FormAttachment(129, 1000, 0);
			label2LData.top =  new FormAttachment(61, 1000, 0);
			label2LData.bottom =  new FormAttachment(956, 1000, 0);
			label2.setLayoutData(label2LData);
			label2.setText("label2");
			final org.eclipse.swt.graphics.Image label2image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newEEnum_wizR.GIF"));
			label2image.setBackground(label2.getBackground());
			label2.setImage(label2image);
			label2.setSize(new org.eclipse.swt.graphics.Point(58,51));
	
			FormData label1LData = new FormData();
			label1LData.height = 52;
			label1LData.width = 64;
			label1LData.left =  new FormAttachment(860, 1000, 0);
			label1LData.right =  new FormAttachment(992, 1000, 0);
			label1LData.top =  new FormAttachment(61, 1000, 0);
			label1LData.bottom =  new FormAttachment(973, 1000, 0);
			label1.setLayoutData(label1LData);
			label1.setText("label1");
			final org.eclipse.swt.graphics.Image label1image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newpack_wiz.gif"));
			label1image.setBackground(label1.getBackground());
			label1.setImage(label1image);
			label1.setSize(new org.eclipse.swt.graphics.Point(64,52));
	
			FormData TitelLbLData = new FormData();
			TitelLbLData.height = 16;
			TitelLbLData.width = 170;
			TitelLbLData.left =  new FormAttachment(143, 1000, 0);
			TitelLbLData.right =  new FormAttachment(495, 1000, 0);
			TitelLbLData.top =  new FormAttachment(201, 1000, 0);
			TitelLbLData.bottom =  new FormAttachment(482, 1000, 0);
			TitelLb.setLayoutData(TitelLbLData);
			TitelLb.setText("Create constraint");
			TitelLb.setSize(new org.eclipse.swt.graphics.Point(170,16));
			TitelLb.setBackground(composite1background);
			final Font TitelLbfont = new Font(Display.getDefault(),"Courier New",12,1);
			TitelLb.setFont(TitelLbfont);
	
			FormData TypeOfContextLData = new FormData();
			TypeOfContextLData.height = 22;
			TypeOfContextLData.width = 241;
			TypeOfContextLData.left =  new FormAttachment(319, 1000, 0);
			TypeOfContextLData.right =  new FormAttachment(818, 1000, 0);
			TypeOfContextLData.top =  new FormAttachment(500, 1000, 0);
			TypeOfContextLData.bottom =  new FormAttachment(885, 1000, 0);
			TypeOfContext.setLayoutData(TypeOfContextLData);
			TypeOfContext.setText("context is a classifier!");
			TypeOfContext.setSize(new org.eclipse.swt.graphics.Point(241,22));
			TypeOfContext.setBackground(composite1background);
			TypeOfContext.setFont(TitelLbfont);
			FormLayout composite1Layout = new FormLayout();
			composite1.setLayout(composite1Layout);
			composite1Layout.marginWidth = 0;
			composite1Layout.marginHeight = 0;
			composite1.layout();
	
			GridData composite2LData = new GridData();
			composite2LData.verticalAlignment = GridData.CENTER;
			composite2LData.horizontalAlignment = GridData.BEGINNING;
			composite2LData.widthHint = 475;
			composite2LData.heightHint = 132;
			composite2LData.horizontalIndent = 0;
			composite2LData.horizontalSpan = 1;
			composite2LData.verticalSpan = 1;
			composite2LData.grabExcessHorizontalSpace = false;
			composite2LData.grabExcessVerticalSpace = false;
			composite2.setLayoutData(composite2LData);
			composite2.setSize(new org.eclipse.swt.graphics.Point(475,132));
	
			FormData TypeInvLData = new FormData();
			TypeInvLData.height = 17;
			TypeInvLData.width = 51;
			TypeInvLData.left =  new FormAttachment(331, 1000, 0);
			TypeInvLData.right =  new FormAttachment(457, 1000, 0);
			TypeInvLData.top =  new FormAttachment(284, 1000, 0);
			TypeInvLData.bottom =  new FormAttachment(465, 1000, 0);
			TypeInv.setLayoutData(TypeInvLData);
			TypeInv.setDoubleClickEnabled(false);
			final Font TypeInvfont = new Font(Display.getDefault(),"Courier New",10,1);
			TypeInv.setFont(TypeInvfont);
			TypeInv.setText("inv");
			TypeInv.setEditable(false);
			TypeInv.setSize(new org.eclipse.swt.graphics.Point(51,17));
			TypeInv.setBackground(composite1background);
			TypeInv.setEnabled(false);
	
			FormData enterParameterLData = new FormData();
			enterParameterLData.height = 20;
			enterParameterLData.width = 150;
			enterParameterLData.left =  new FormAttachment(605, 1000, 0);
			enterParameterLData.right =  new FormAttachment(921, 1000, 0);
			enterParameterLData.top =  new FormAttachment(761, 1000, 0);
			enterParameterLData.bottom =  new FormAttachment(912, 1000, 0);
			enterParameter.setLayoutData(enterParameterLData);
			enterParameter.setText("enter parameter");
			enterParameter.setSize(new org.eclipse.swt.graphics.Point(150,20));
			final Font enterParameterfont = new Font(Display.getDefault(),"Courier New",8,1);
			enterParameter.setFont(enterParameterfont);
			enterParameter.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					enterParameterMouseDown(evt);
				}
			});
	
			FormData VarOfConLData = new FormData();
			VarOfConLData.height = 13;
			VarOfConLData.width = 273;
			VarOfConLData.left =  new FormAttachment(331, 1000, 0);
			VarOfConLData.right =  new FormAttachment(921, 1000, 0);
			VarOfConLData.top =  new FormAttachment(511, 1000, 0);
			VarOfConLData.bottom =  new FormAttachment(662, 1000, 0);
			VarOfCon.setLayoutData(VarOfConLData);
			final Font VarOfConfont = new Font(Display.getDefault(),"Courier New",10,0);
			VarOfCon.setFont(VarOfConfont);
			VarOfCon.setSize(new org.eclipse.swt.graphics.Point(273,13));
	
			FormData NameOfVarLData = new FormData();
			NameOfVarLData.height = 18;
			NameOfVarLData.width = 150;
			NameOfVarLData.left =  new FormAttachment(5, 1000, 0);
			NameOfVarLData.right =  new FormAttachment(321, 1000, 0);
			NameOfVarLData.top =  new FormAttachment(511, 1000, 0);
			NameOfVarLData.bottom =  new FormAttachment(647, 1000, 0);
			NameOfVar.setLayoutData(NameOfVarLData);
			NameOfVar.setText("Variable of context");
			NameOfVar.setSize(new org.eclipse.swt.graphics.Point(150,18));
			NameOfVar.setFont(TypeInvfont);
	
			FormData NameOfContextTxtLData = new FormData();
			NameOfContextTxtLData.height = 13;
			NameOfContextTxtLData.width = 273;
			NameOfContextTxtLData.left =  new FormAttachment(331, 1000, 0);
			NameOfContextTxtLData.right =  new FormAttachment(921, 1000, 0);
			NameOfContextTxtLData.top =  new FormAttachment(117, 1000, 0);
			NameOfContextTxtLData.bottom =  new FormAttachment(268, 1000, 0);
			NameOfContextTxt.setLayoutData(NameOfContextTxtLData);
			NameOfContextTxt.setFont(VarOfConfont);
			NameOfContextTxt.setSize(new org.eclipse.swt.graphics.Point(273,13));
	
			FormData NameOfContextLData = new FormData();
			NameOfContextLData.height = 17;
			NameOfContextLData.width = 120;
			NameOfContextLData.left =  new FormAttachment(68, 1000, 0);
			NameOfContextLData.right =  new FormAttachment(321, 1000, 0);
			NameOfContextLData.top =  new FormAttachment(132, 1000, 0);
			NameOfContextLData.bottom =  new FormAttachment(261, 1000, 0);
			NameOfContext.setLayoutData(NameOfContextLData);
			NameOfContext.setText("Name of context");
			NameOfContext.setSize(new org.eclipse.swt.graphics.Point(120,17));
			NameOfContext.setFont(TypeInvfont);
	
			FormData IsClassifierBLData = new FormData();
			IsClassifierBLData.height = 18;
			IsClassifierBLData.width = 20;
			IsClassifierBLData.left =  new FormAttachment(788, 1000, 0);
			IsClassifierBLData.right =  new FormAttachment(830, 1000, 0);
			IsClassifierBLData.top =  new FormAttachment(321, 1000, 0);
			IsClassifierBLData.bottom =  new FormAttachment(458, 1000, 0);
			IsClassifierB.setLayoutData(IsClassifierBLData);
			IsClassifierB.setSelection(true);
			IsClassifierB.setSize(new org.eclipse.swt.graphics.Point(20,18));
			IsClassifierB.setFont(TypeInvfont);
			IsClassifierB.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					IsClassifierBWidgetSelected(evt);
				}
			});
	
			FormData IsCclassifierLData = new FormData();
			IsCclassifierLData.height = 18;
			IsCclassifierLData.width = 133;
			IsCclassifierLData.left =  new FormAttachment(504, 1000, 0);
			IsCclassifierLData.right =  new FormAttachment(784, 1000, 0);
			IsCclassifierLData.top =  new FormAttachment(314, 1000, 0);
			IsCclassifierLData.bottom =  new FormAttachment(450, 1000, 0);
			IsCclassifier.setLayoutData(IsCclassifierLData);
			IsCclassifier.setAlignment(SWT.LEFT);
			IsCclassifier.setText("Is it classifier");
			IsCclassifier.setSize(new org.eclipse.swt.graphics.Point(133,18));
			IsCclassifier.setEnabled(true);
			IsCclassifier.setFont(TypeInvfont);
	
			FormData NameTxtLData = new FormData();
			NameTxtLData.height = 13;
			NameTxtLData.width = 273;
			NameTxtLData.left =  new FormAttachment(331, 1000, 0);
			NameTxtLData.right =  new FormAttachment(921, 1000, 0);
			NameTxtLData.top =  new FormAttachment(-26, 1000, 0);
			NameTxtLData.bottom =  new FormAttachment(125, 1000, 0);
			NameTxt.setLayoutData(NameTxtLData);
			NameTxt.setFont(VarOfConfont);
			NameTxt.setSize(new org.eclipse.swt.graphics.Point(273,12));
	
			FormData TypeTxtLData = new FormData();
			TypeTxtLData.height = 13;
			TypeTxtLData.width = 267;
			TypeTxtLData.left =  new FormAttachment(331, 1000, 0);
			TypeTxtLData.right =  new FormAttachment(921, 1000, 0);
			TypeTxtLData.top =  new FormAttachment(511, 1000, 0);
			TypeTxtLData.bottom =  new FormAttachment(662, 1000, 0);
			TypeTxt.setLayoutData(TypeTxtLData);
			TypeTxt.setEditable(true);
			TypeTxt.setSize(new org.eclipse.swt.graphics.Point(267,13));
			TypeTxt.setBackground(composite1background);
	
			FormData KindLbLData = new FormData();
			KindLbLData.height = 18;
			KindLbLData.width = 144;
			KindLbLData.left =  new FormAttachment(20, 1000, 0);
			KindLbLData.right =  new FormAttachment(323, 1000, 0);
			KindLbLData.top =  new FormAttachment(306, 1000, 0);
			KindLbLData.bottom =  new FormAttachment(443, 1000, 0);
			KindLb.setLayoutData(KindLbLData);
			KindLb.setText("Kind of constraint");
			KindLb.setSize(new org.eclipse.swt.graphics.Point(144,18));
			KindLb.setFont(TypeInvfont);
	
			FormData KindCMbLData = new FormData();
			KindCMbLData.height = 24;
			KindCMbLData.width = 33;
			KindCMbLData.left =  new FormAttachment(331, 1000, 0);
			KindCMbLData.right =  new FormAttachment(457, 1000, 0);
			KindCMbLData.top =  new FormAttachment(284, 1000, 0);
			KindCMbLData.bottom =  new FormAttachment(465, 1000, 0);
			KindCMb.setLayoutData(KindCMbLData);
			KindCMb.setText("inv");
			KindCMb.setOrientation(SWT.HORIZONTAL);
			KindCMb.setSize(new org.eclipse.swt.graphics.Point(33,24));
			KindCMb.setFont(TypeInvfont);
	
			FormData TypeLbLData = new FormData();
			TypeLbLData.height = 18;
			TypeLbLData.width = 113;
			TypeLbLData.left =  new FormAttachment(85, 1000, 0);
			TypeLbLData.right =  new FormAttachment(323, 1000, 0);
			TypeLbLData.top =  new FormAttachment(511, 1000, 0);
			TypeLbLData.bottom =  new FormAttachment(647, 1000, 0);
			TypeLb.setLayoutData(TypeLbLData);
			TypeLb.setText("Type of method");
			TypeLb.setSize(new org.eclipse.swt.graphics.Point(113,18));
			TypeLb.setFont(TypeInvfont);
	
			FormData NameLbLData = new FormData();
			NameLbLData.height = 17;
			NameLbLData.width = 143;
			NameLbLData.left =  new FormAttachment(22, 1000, 0);
			NameLbLData.right =  new FormAttachment(323, 1000, 0);
			NameLbLData.top =  new FormAttachment(-11, 1000, 0);
			NameLbLData.bottom =  new FormAttachment(117, 1000, 0);
			NameLb.setLayoutData(NameLbLData);
			NameLb.setText("Name of constraint");
			NameLb.setSize(new org.eclipse.swt.graphics.Point(143,16));
			NameLb.setFont(TypeInvfont);
			FormLayout composite2Layout = new FormLayout();
			composite2.setLayout(composite2Layout);
			composite2Layout.marginWidth = 0;
			composite2Layout.marginHeight = 0;
			composite2.layout();
	
			GridData composite3LData = new GridData();
			composite3LData.verticalAlignment = GridData.CENTER;
			composite3LData.horizontalAlignment = GridData.BEGINNING;
			composite3LData.widthHint = 482;
			composite3LData.heightHint = 51;
			composite3LData.horizontalIndent = 0;
			composite3LData.horizontalSpan = 1;
			composite3LData.verticalSpan = 1;
			composite3LData.grabExcessHorizontalSpace = false;
			composite3LData.grabExcessVerticalSpace = false;
			composite3.setLayoutData(composite3LData);
			composite3.setSize(new org.eclipse.swt.graphics.Point(482,51));
	
			FormData CancelLData = new FormData();
			CancelLData.height = 20;
			CancelLData.width = 100;
			CancelLData.left =  new FormAttachment(706, 1000, 0);
			CancelLData.right =  new FormAttachment(913, 1000, 0);
			CancelLData.top =  new FormAttachment(205, 1000, 0);
			CancelLData.bottom =  new FormAttachment(598, 1000, 0);
			Cancel.setLayoutData(CancelLData);
			Cancel.setText("cancel");
			Cancel.setSize(new org.eclipse.swt.graphics.Point(100,20));
			Cancel.setFont(TypeInvfont);
			Cancel.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					CancelMouseDown(evt);
				}
			});
	
			FormData EnterLData = new FormData();
			EnterLData.height = 20;
			EnterLData.width = 100;
			EnterLData.left =  new FormAttachment(478, 1000, 0);
			EnterLData.right =  new FormAttachment(685, 1000, 0);
			EnterLData.top =  new FormAttachment(205, 1000, 0);
			EnterLData.bottom =  new FormAttachment(598, 1000, 0);
			Enter.setLayoutData(EnterLData);
			Enter.setText("enter");
			Enter.setSize(new org.eclipse.swt.graphics.Point(100,20));
			Enter.setFont(TypeInvfont);
			Enter.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					EnterMouseDown(evt);
				}
			});
			FormLayout composite3Layout = new FormLayout();
			composite3.setLayout(composite3Layout);
			composite3Layout.marginWidth = 0;
			composite3Layout.marginHeight = 0;
			composite3.layout();
			GridLayout dialogShellLayout = new GridLayout(1, true);
			dialogShell.setLayout(dialogShellLayout);
			dialogShellLayout.marginWidth = 5;
			dialogShellLayout.marginHeight = 5;
			dialogShellLayout.numColumns = 1;
			dialogShellLayout.makeColumnsEqualWidth = true;
			dialogShellLayout.horizontalSpacing = 5;
			dialogShellLayout.verticalSpacing = 5;
			dialogShell.layout();
			dialogShell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					composite1background.dispose();
					label2image.dispose();
					label1image.dispose();
					TitelLbfont.dispose();
					TypeInvfont.dispose();
					enterParameterfont.dispose();
					VarOfConfont.dispose();
				}
			});
			Rectangle bounds = dialogShell.computeTrim(0, 0, 490,258);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI(){
		state=false;
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI(){
		KindCMb.add("pre");
		KindCMb.add("post");
		KindCMb.select(0);
		KindCMb.setVisible(false);
		enterParameter.setVisible(false);
		TypeOfContext.setForeground(new Color(Display.getDefault(),255,0,128));
		TypeTxt.setVisible(false);
		TypeLb.setVisible(false);

	}

	/** Auto-generated main method */
	public static void main(String[] args){
		showGUI();
	}

	/**
	* This static method creates a new instance of this class and shows
	* it inside a new Shell.
	*
	* It is a convenience method for showing the GUI, but it can be
	* copied and used as a basis for your own code.	*
	* It is auto-generated code - the body of this method will be
	* re-generated after any changes are made to the GUI.
	* However, if you delete this method it will not be re-created.	*/
	public static void showGUI(){
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			CreateConstraintDialog inst = new CreateConstraintDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Auto-generated event handler method */
	protected void CancelMouseDown(MouseEvent evt){
		state = false;
		dialogShell.close();
	}

	/** Auto-generated event handler method */
	protected void EnterMouseDown(MouseEvent evt){
		state = true;
		nameConstraint=NameTxt.getText();
		nameContext=NameOfContextTxt.getText();
		variable=VarOfCon.getText();
		typeC=TypeTxt.getText();
		isCl=IsClassifierB.getSelection();
		if(isCl)kindC=0;
		else kindC=KindCMb.getSelectionIndex()+1;

		dialogShell.close();
	}
	
	/**
	* @return
	*/
	public boolean isCl() {	return isCl;}
	
	/**
	* @return
	*/
	public int getKindC() {return kindC;}

	/**
	* @return
	*/
	public String getNameConstraint() {return nameConstraint;}

	/**
	* @return
	*/
	public String getNameContext() {return nameContext;}
	
	/**
	* @return
	*/
	public boolean isState() {return state;}
	
	/**
	* @return
	*/
	public String getTypeC() {return typeC;}
	
	/**
	* @return
	*/
	public String getVariable() {return variable;}
	
	/** Auto-generated event handler method */
	protected void enterParameterMouseDown(MouseEvent evt){
		CreateMethodContextDialog cmcd = new CreateMethodContextDialog(dialogShell,parameter);
		cmcd.open();
		parameter=cmcd.getParam();
	}
	
	/** Auto-generated event handler method */
	protected void IsClassifierBWidgetSelected(SelectionEvent evt){
		if(IsClassifierB.getSelection()){
			VarOfCon.setVisible(true);
			NameOfVar.setVisible(true);
			TypeTxt.setVisible(false);
			TypeLb.setVisible(false);
			enterParameter.setVisible(false);
			KindCMb.setVisible(false);
			TypeInv.setVisible(true);
			TypeOfContext.setText(strClassifier);
		}else{
			VarOfCon.setVisible(false);
			NameOfVar.setVisible(false);
			TypeTxt.setVisible(true);
			TypeLb.setVisible(true);
			enterParameter.setVisible(true);	
			KindCMb.setVisible(true);
			TypeInv.setVisible(false);	
			TypeOfContext.setText(strMethod);	
		}		
	}
	
	//Return the List of parameter for the Method
	public List getParameter(){
		return parameter;
	}

	/**
	* This is an auto-generated method which you can alter,
	* e.g. to point to a different property file, to modify the key by
	* by prefixing the name of this class, etc.
	*
	* By default, it expects a file called "messages.properties" to exist in the
	* current package, and returns the value of the property defined
	* in that file for the given key
	*/
	public String getExternalizedString(String key){
		try {
			return java.util.ResourceBundle.getBundle("vocleditor.dialogs.CreateConstraintDialogMessages").getString(key);
		} catch (java.util.MissingResourceException e) {
			return '!' + key + '!';
		}
	}
}
