package de.tuberlin.tfs.ocl.metamodel.expressions;

import de.tuberlin.tfs.ocl.metamodel.converter.NoSuchAttributeException;
import de.tuberlin.tfs.ocl.metamodel.converter.OclConverter;


public class MIfExpImpl extends MOclExpressionImpl implements MIfExp {

	protected MOclExpression condition;
	protected MOclExpression theExpression;
	protected MOclExpression elseExpression;


	/** Getter for property condition.
	 * @return Value of property condition.
	 */
	public MOclExpression getCondition() {
		return condition;
	}

	/** Setter for property condition.
	 * @param condition value of property condition.
	 */
	public void  setCondition(MOclExpression condition) {
		this.condition = condition;
	}

	/** Getter for property theExpression.
	 * @return Value of property theExpression.
	 */
	public MOclExpression getTheExpression() {
		return theExpression;
	}

	/** Setter for property theExpression.
	 * @param theExpression value of property theExpression.
	 */
	public void  setTheExpression(MOclExpression theExpression) {
		this.theExpression = theExpression;
	}

	/** Getter for property elseExpression.
	 * @return Value of property elseExpression.
	 */
	public MOclExpression getElseExpression() {
		return elseExpression;
	}

	/** Setter for property elseExpression.
	 * @param elseExpression value of property elseExpression.
	 */
	public void  setElseExpression(MOclExpression elseExpression) {
		this.elseExpression = elseExpression;
	}



	public String convert2OclString () throws NoSuchAttributeException {

		OclConverter.message("<MIfExp>");

		StringBuffer strB = new StringBuffer();

		strB.append("if ");
		
		OclConverter.checkAttribute(condition, "condition", this);

		strB.append(condition.convert2OclString() + " then ");

		OclConverter.checkAttribute(theExpression, "'then' expression", this);

		strB.append(theExpression.convert2OclString() + " else ");

		OclConverter.checkAttribute(elseExpression, "'else' expression", this);

		strB.append(elseExpression.convert2OclString() + " endif");

		OclConverter.message("</MIfExp>");
		return strB.toString();

	}

}
