package de.tuberlin.tfs.ocl.metamodel.expressions;

// import java.util.*;
// import de.tuberlin.tfs.ocl.metamodel.types.*;
import de.tuberlin.tfs.ocl.metamodel.converter.*;
// import ru.novosoft.uml.foundation.core.*;
// import ru.novosoft.uml.foundation.data_types.*;
// import ru.novosoft.uml.behavior.common_behavior.*;


public class MIteratorExpImpl extends MLoopExpImpl implements MIteratorExp {





	public String convert2OclString () throws NoSuchAttributeException {
		StringBuffer strB = new StringBuffer();

		OclConverter.message("<MIteratorExp>");

		// look for source
		if (source != null) {
			OclConverter.message("source found.");

			strB.append(source.convert2OclString() );

			if (source.getType() != null) strB.append("->");
			else OclConverter.warning("source has no type.");
		}
		else OclConverter.message("no source found.");


		// e.g. select( a | exp )
		OclConverter.checkAttribute(getName(), "name", this);

		strB.append(getName() + "(");

		OclConverter.checkAttribute(iterator, "iterator", this);

		strB.append(iterator.convert2OclString() );

		OclConverter.checkAttribute(iterator.getType(), "type of iterator", this);

		strB.append(": " + iterator.getType().getName() + " | ");

		OclConverter.checkAttribute(body, "body", this);

		strB.append(body.convert2OclString() + ")" );

		OclConverter.message("</MIteratorExp>");
		return strB.toString();
	}

}
