package de.tuberlin.tfs.ocl.metamodel.expressions;

import java.util.*;
// import de.tuberlin.tfs.ocl.metamodel.types.*;
import de.tuberlin.tfs.ocl.metamodel.converter.*;
import ru.novosoft.uml.foundation.core.*;
// import ru.novosoft.uml.foundation.data_types.*;
// import ru.novosoft.uml.behavior.common_behavior.*;


public class MNavigationCallExpImpl extends MModelPropertyCallExpImpl implements MNavigationCallExp {

	protected ArrayList qualifiers;
	protected MAssociationEnd navigationSource;


	/** Getter for property qualifiers.
	 */
	public List getQualifiers() {
		if( this.qualifiers == null) {
			return new ArrayList();
		}
		ArrayList l = new ArrayList();
		Iterator i = this.qualifiers.iterator();
		while(i.hasNext()) {
			l.add(i.next());
		}
		return l;
	}

	/** Setter for property qualifiers.
	 */
	public void  setQualifiers(List qualifiers) {
		//maybe unset some link Information ????

		this.qualifiers = new ArrayList();
		Iterator i = qualifiers.iterator();
		while(i.hasNext()) {
			this.qualifiers.add(i.next());
		}
	}

	/** Adder for property qualifiers.
	 */
	public void addQualifiers(MOclExpression qualifiers) {
		if(this.qualifiers == null) {
			this.qualifiers = new ArrayList();
		}
		this.qualifiers.add(qualifiers);
		//qualifiers.internalSetEnum(this);
	}

	/** Remover for property qualifiers.
	 */
	public void removeQualifiers(MOclExpression qualifiers) {
		if(this.qualifiers == null) {
			this.qualifiers = new ArrayList();
		}
		this.qualifiers.remove(qualifiers);
		//qualifiers.internalSetEnum(null);
	}


	/** Getter for property navigationSource.
	 * @return Value of property navigationSource.
	 */
	public MAssociationEnd getNavigationSource() {
		return navigationSource;
	}

	/** Setter for property navigationSource.
	 * @param navigationSource value of property navigationSource.
	 */
	public void  setNavigationSource(MAssociationEnd navigationSource) {
		this.navigationSource = navigationSource;
	}



	public String convert2OclString () throws NoSuchAttributeException {
		OclConverter.warning(this.toString()
			+ "cannot be converted. Please select a derived class.");

		return ("");
	}

}
