/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.editors;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;


public interface VOCLEditorConstants {

	Color titleColor = new Color(null,200,214,251);	
	
	Color container = new Color(null,240,245,245);	
	
	Color classColor = new Color(null,255,255,206);
	
	Color negateColor = new Color(null,255,100,100); //144,126);
	
	Font font = new Font(null, "Arial", 8, SWT.BOLD);
	
	Font classFont = new Font(null, "Arial", 12, SWT.BOLD);

	// constants for properties of classifiernode (set or simple)
	public static final String STATE 				= "STATE";
	public static final String SET_SIZE_VAR 		= "SET_SIZE_VAR";
	public static final String CLASS_NAME			= "CLASS_NAME";
	public static final String CLASS_VAR_NAME 		= "CLASS_VAR_NAME";
	public static final String ATTRIBUTES			= "ATTRIBUTES";
	public static final String SUMMAND_VAR			= "SUMMAND_VAR";
	public static final String METHOD_NAME			= "METHOD_NAME";
	public static final String METHOD_TYPE			= "METHOD_TYPE";
	public static final String METHOD_RETURN_NAME	= "METHOD_RETURN_NAME";	
	public static final String METHOD_PARAMETER		= "METHOD_PARAMETER";
	
	public static final String PREDICAT_ITERATORS	= "PREDICAT_ITERATORS";
	public static final String PREDICAT_TYPE		= "PREDICAT_TYPE";
	public static final String PREDICAT_SET_NAME		= "PREDICAT_SET_NAME";
	public static final String PREDICAT_SET_TYPE		= "PReDICAT_SET_TYPE";


}
